------------------------------------------------------------
-- Lab1.vhd: Contains cnt1s, SignExtend
-- Author:   Enter your name here
------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all; 
use ieee.numeric_std.all;
------------------------------------------------------------
-- entity:  Cnt1s - Counts number of input bits of X that
--                  are 1 and outputs this value on Y.
-- generic: N   - Number of bits
-- port:    X   - Input signal of N bits
--          Y   - Output signal of N bits
------------------------------------------------------------
ENTITY cnt1s IS
     GENERIC(N : integer := 32);
     PORT(X: IN unsigned(N-1 downto 0);
          Y: OUT unsigned(N-1 downto 0));
END ENTITY cnt1s;

ARCHITECTURE behav OF cnt1s IS
BEGIN
    PROCESS(X) is
        VARIABLE Cnt: INTEGER range 0 to N;        
    BEGIN
        FOR I in 0 to N-1 loop
            IF X(I) = '1' THEN
               Cnt := Cnt+1;
            END IF;                    
        END LOOP;
        Y <= TO_UNSIGNED(Cnt, N);        
    END PROCESS;
END ARCHITECTURE behav;

------------------------------------------------------------
-- entity:  SignExtend  - Extends sign bit of M bit word X 
--          to produce N bit output Y.
-- Note:    Assumes N > M
-- generic: M   - Number of bits in X
--          N   - Number of bits in Y
-- port:    X   - Input signal of M bits
--          Y   - Output signal of N bits
------------------------------------------------------------
library IEEE;
USE IEEE.Std_Logic_1164.all; 
use ieee.numeric_std.all;

ENTITY SignExtend is
    GENERIC(M: integer := 16; N: integer := 32);
    PORT(X : IN signed(M-1 downto 0);
         Y : OUT signed(N-1 downto 0)
         );
END SignExtend;

ARCHITECTURE behav OF SignExtend IS
BEGIN
    Y(N-1 downto M) <= (others => X(M-1));
END behav;
